/*
Tree32
is like the old fashioned "tree.com" for dos 5.0 and over, but supports long 
file names.

Copyright (C) 1999  by Lorenzo Trivelli

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <tchar.h>

//Messages :
#define ERR_N_PAR	"Bad number of arguments !"
#define ERR_PAR		"Bad argument passed !"
#define ERR_DIR		"Directory not found !"
#define MSG_STR		"Structure of"
#define V_SEP		"|"
#define H_SEP		"--"
#define PAR_S_A		"\\*.*"
#define PAR_A		"*.*"
#define PRGNAME         "Tree32 v 1.02 (GNU GPL FREE SOFTWARE)"
#define CPYRGHT         "copyright 1999 by Lorenzo Trivelli \nType tree32 -h for help"
#define USAGE           "usage :  tree32 [directory]"

void PrintError(char * str,short exitcode);
void ScanDir(HANDLE hDirBase,char *z,short n);

//Global Variables
char k[_MAX_PATH+16];
LPWIN32_FIND_DATA lpwData;

int main(int argc, char ** argv)
{
HANDLE hDirBase,hAux;
char szBaseDir[_MAX_PATH+6];
short j;
#ifdef _DEBUG
char ch;
#endif

printf("%s\n%s\n",PRGNAME,CPYRGHT);
//Argument check
switch (argc)
{
case 1:
	{
	strcpy(szBaseDir, ".");
	break;
	}
case 2:
	{
	if(strcmp(argv[1],"-h")==0 )
		{
		printf("\n%s\n", USAGE);
		return 0;
		} else 
		strcpy(szBaseDir,argv[1]);
	
	break;
	}
default:
PrintError(ERR_N_PAR,1);
}


lpwData=(LPWIN32_FIND_DATA) malloc(sizeof(WIN32_FIND_DATA));

j=strlen(szBaseDir);


if(szBaseDir[j-1] == 0x5C)
	strcat(szBaseDir,PAR_A);
else
	strcat(szBaseDir,PAR_S_A);

hDirBase=FindFirstFile(szBaseDir,lpwData);

//Check if directory exist
if(hDirBase==INVALID_HANDLE_VALUE)
	PrintError(ERR_DIR,3);

//Print startup message
printf("%s %s\n",MSG_STR,((argc==2) ? argv[1] : "."));

//Compare the first directory entry with "."
if(strcmp(lpwData->cFileName,".")==0)
	ScanDir(hDirBase,szBaseDir,0);		//If "." exists
else
{	
if(lpwData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
	{
	char szAux[64];						//else,if the handle refers to a directory
	strcpy(szAux,argv[1]);
	j=strlen(szAux);
	
	if(szAux[j-1] != 0x5C)
		strcat(szAux,"\\");

	strcat(szAux,lpwData->cFileName);
	strcat(szAux,PAR_S_A);
	printf("%s\n",lpwData->cFileName);
	hAux=FindFirstFile(szAux,lpwData);
	ScanDir(hAux,szAux,1);

	}


ScanDir(hDirBase,szBaseDir,0);			//Normal scan
} 
	
free(lpwData);

#ifdef _DEBUG
ch=getchar();
#endif
return 0;
}


/*********************************************************************************\
PrintError
	Params:		
		char*str		=	error message to print
		short exitcode	=	0	, recoverable error
							!0	,	ends the app

	Returns:
		nothing
\*********************************************************************************/
void PrintError(char * str,short exitcode)
{
fprintf(stderr,"\n%s\n",str);
fprintf(stderr,"\n%s\n",USAGE);
if(exitcode) exit(exitcode);
}

/*********************************************************************************\
ScanDir
	Params:	
		HANDLE hDirBase	=	handle to the directory
		char  * z		=	string of the directory, with ending \*.*
		short n			=	level of subdirectory
\*********************************************************************************/
void ScanDir(HANDLE hDirBase,char *z,short n) 
{
HANDLE h;
short j,i;

//Main Dir Pump
while(FindNextFile(hDirBase,lpwData) )
{
if((lpwData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)  && (strcmp(lpwData->cFileName,"..")!=0) )
	{
	for(i=1;i<=n;i++)
		printf("%s%s",V_SEP,H_SEP);

	printf("%s\n",lpwData->cFileName);
	
	strcpy(k,z);
	j=strlen(k);
	k[j-3]='\0';
	strcat(k,lpwData->cFileName);
	j--;

	if(k[j]== '\\')
		strcat(k,PAR_A);
	else
		strcat(k,PAR_S_A);



	h=FindFirstFile(k,lpwData);
	
	if(h!=INVALID_HANDLE_VALUE)
		ScanDir(h,k,n+1);
		
	}
}
return;
}

